<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml">
<head>
<meta http-equiv="Content-Type" content="text/html; charset=iso-8859-1" />
<title>Update from Version 1.0.2 to 1.0.5</title>
</head>
<body>
<?php
/**

	Plazieren Sie diese Datei in das Hauptverzeichniss Ihrer Contrexx Installation
	und klicken Sie anschliessend auf "Update starten".

*/
if (!@include_once('config/configuration.php')) {
	print "Plazieren Sie diese Datei in das Hauptverzeichniss Ihrer Contrexx Installation.";
} else {
?>
<form action="<?php echo $_SERVER['PHP_SELF'];?>" method="post">
<?php

	$objUpdate = &new Update();
	if (!isset($_POST['doUpdate'])) {
		print "<input type=\"submit\" name=\"doUpdate\" value=\"Update ausfhren\" />";
		
	} else {
		require_once ASCMS_CORE_PATH.'/API.php';
		
		
		$errorMsg = '';
		$objDatabase = getDatabaseObject($errorMsg);
		
		$objUpdate->doUpdate();
	}
}



class Update
{
	var $updateFinished = false;
	var $errorMsg = "";
	var $dbPrefix = "contrexx_";
	var $configFile = "/config/configuration.php";
	var $versionFile = "/config/version.php";
	var $sqlFile = "contrexx_opensource_update_1.0.2-1.0.5.sql";
	var $oldPrefix;
	var $arrTables = array(
		'group_backend_permissions',
		'pagecounter',
		'searchbots',
		'stats',
		'user_groups',
		'users',
		'backend_areas',
		'backups',
		'content',
		'content_navigation',
		'ids',
		'languages',
		'log',
		'modules',
		'module_news',
		'module_news_settings',	
		'module_news_categories',
		'module_repository',
		'sessions',
		'settings',
		'skins',
		'module_feed_category',
		'module_feed_news',
		'module_calendar',
		'module_calendar_categories',
		'module_calendar_style',
		'module_docsys',
		'module_docsys_categories',
		'module_gallery_categories',
		'module_gallery_pictures',
		'module_gallery_settings',
		'module_guestbook',
		'newsletter_archiv',
		'newsletter_emails',
		'newsletter_lists',
		'newsletter_settings',
		'stats_browser',
		'stats_colourdepth',
		'stats_config',
		'stats_country',
		'stats_hostname',
		'stats_javascript',
		'stats_operatingsystem',
		'stats_referer',
		'stats_requests',
		'stats_requests_summary',
		'stats_screenresolution',
		'stats_search',
		'stats_spiders',
		'stats_spiders_summary',
		'stats_visitors',
		'stats_visitors_summary',
		'voting_results',
		'voting_system'
	);
	
	var $arrFiles;
	
	function Update() {
		$this->__constructor();
	}
	
	function __constructor() {
		$this->oldPrefix = DBPREFIX;
		
		
		$this->arrFiles = array(
			'/admin/backup' => array(
				'mode'		=> '0777',
				'mode_oct'	=> 0777
			),
			'/feed'	=> array(
				'mode'		=> '0777',
				'mode_oct'	=> 0777
			),
			'/media'	=> array(
				'mode'		=> '0777',
				'mode_oct'	=> 0777,
				'sub_dirs'	=> true
			),
			'/images'	=> array(
				'mode'		=> '0777',
				'mode_oct'	=> 0777,
				'sub_dirs'	=> true
			),
			'/themes'	=> array(
				'mode'		=> '0777',
				'mode_oct'	=> 0777,
				'sub_dirs'	=> true
			),
			'/tmp'		=> array(
				'mode'		=> '0777',
				'mode_oct'	=> 0777,
				'sub_dirs'	=> true
			),
			$this->configFile => array(
				'mode'		=> '0706',
				'mode_oct'	=> 0706
			),
			$this->versionFile => array(
				'mode'		=> '0706',
				'mode_oct'	=> 0706
			)
		);
	}
	
	function doUpdate() {
		
		$this->_checkPermissions();
		if (!$this->checkDbPrefix()) {
			$this->_renameDbTablePrefix();
			$this->_writeAlternatedConfigurationFile();
		}
		$this->_removeUnnededFiles();
		$this->_migratePermissionSystem();
		$this->_updateDb();
		$this->_addCssNameToTableContent();
		$this->_dropUnnededTables();
		
		if (!empty($this->errorMsg)) {
			print "Updatevorgang war nicht erfolgreich!<br /><br />\n";
			print $this->errorMsg;
		} else {
			print "Updatevorgang wurde erfolgreich abgeschlossen.";
		}
	}
	
	function _dropUnnededTables()
	{
		global $objDatabase;
		
		$objDatabase->Execute("DROP TABLE `contrexx_pagecounter` , `contrexx_searchbots` , `contrexx_stats`");
	}
	
	function _removeUnnededFiles() {
		@unlink(dirname(__FILE__).'/config/version.xml');
		@unlink(dirname(__FILE__).'/config/set_system.php');
		@unlink(dirname(__FILE__).'/config/base64.php');
	}
	
	function checkDbPrefix() {
		if ($this->oldPrefix == $this->dbPrefix) {
			return true;
		} else {
			return false;
		}
	}
	
	function _addCssNameToTableContent() {
		global $objDatabase;
		
		$arrColumns = $objDatabase->MetaColumnNames($this->oldPrefix."content");
		if (!in_array('css_name', $arrColumns)) {
			if ($objDatabase->Execute("ALTER TABLE `".$this->oldPrefix."content` ADD `css_name` VARCHAR( 50 ) NOT NULL AFTER `metarobots`") === false) {
				$this->errorMsg .= "Fehler bei einfgen der Spalte <i>css_name</i> in der Tabelle <i>".$this->oldPrefix."content</i>!<br />";
				$this->errorMsg .= "Datenbank Meldung: ".$objDatabase->ErrorMsg()."<br />";
			}
		}
	}
	
	function _renameDbTablePrefix() {
		global $objDatabase;
		
		foreach ($this->arrTables as $table) {
			if ($objDatabase->Execute("ALTER TABLE `".$this->oldPrefix.$table."` RENAME `".$this->dbPrefix.$table."`") === false) {
				$this->errorMsg .= "Die Tabelle <b>".$this->oldPrefix.$table."</b> konnte nicht umbennannt werden!<br />\n";
				$this->errorMsg .= "<ul><li>Datenbank Fehler: <i>".$objDatabase->ErrorMsg()."</i></ul></li><br /><br />\n";
			}
		}
		$this->oldPrefix = $this->dbPrefix;
	}
	
	function _writeAlternatedConfigurationFile() {
		$newConfigurationContent = "";
		
		$configurationContent = @file(dirname(__FILE__).$this->configFile);
		$fp = @fopen(dirname(__FILE__).$this->configFile,'w');
		if (!empty($configurationContent) && $fp) {
			foreach ($configurationContent as $line) {
				if (preg_match('/\$_DBCONFIG\[\'tablePrefix\'\]\s*=\s*"(.*)";/',$line, $arrMatches)) {
					$line = preg_replace('='.$arrMatches[1].'=',$this->dbPrefix, $line);
					fputs($fp, $line);
				} else {
					fputs($fp, $line);
				}
			}
		} else {
			$this->errorMsg .= "Die Konfigurationsdatei konnte nicht aktualisiert werden!<br />\n";
			$this->errorMsg .= "Sie mssen nun in der Konfigurationsdatei <i>".$this->configFile."</i> das Datenbanktabellenprfix <i>tablePrefix</i> auf <i>".$this->dbPrefix."</i> ndern!<br />\n";
		}
			
	}
	
	function _updateDb() {
		global $objDatabase;
		
		ini_set('auto_detect_line_endings',true);
		$fp = @fopen(dirname(__FILE__).'/'.$this->sqlFile,'r');
		if ($fp) {
			while (!feof($fp)) {
				$query = fgets($fp);
				if (!$this->checkDbPrefix()) {
					$query = str_replace($this->dbPrefix, $this->oldPrefix, $query);
				}
				if ($objDatabase->Execute($query) === false) {
					$this->errorMsg .= "<b>Fehler bei ausfhrern der folgenden Datenbankabfrage:</b><br />\n";
					$this->errorMsg .= "<ul><li><i>".$query."</i></li>\n";
					$this->errorMsg .= "<li>Datenbank Meldung: <i>".$objDatabase->ErrorMsg()."</i></li></ul><br /><br />\n";
				}
			}
			fclose($fp);
		} else {
			$this->errorMsg .= "Konnte die SQL-Updatedatei <b>".$this->sqlFile."</b> nicht ffnen!<br /><br />\n";
		}
	}
	
	function _checkPermissions() {
		global $_PATHCONFIG;
		
		$statusMessage = "";
		$path = $_PATHCONFIG['ascms_root'].$_PATHCONFIG['ascms_root_offset'];
		
		foreach ($this->arrFiles as $file => $arrAttributes) {
			$arrAllFiles = array();
			$arrSubDirs = array();
			
			if (isset($arrAttributes['sub_dirs']) && $arrAttributes['sub_dirs']) {
				$arrSubDirs = $this->_getSubDirs($file);
				$arrAllFiles = array_merge(array($file), $arrSubDirs);
			} else {
				$arrAllFiles = array($file);
			}
			
			foreach ($arrAllFiles as $checkFile) {
				if (!is_writable($path.$checkFile)) {
					if ($this->isWindows()) {
						if (empty($statusMessage)) {
							$statusMessage = "Sie mssen den folgenden Dateien Schreibberechtigung zuweisen:<br />";
						}
						$statusMessage .= $path.$checkFile."<br />";
					} else {
						$result = $this->_chmod($checkFile, $arrAttributes);
						if ($result !== true) {
							$statusMessage .= $result;
						}
					}
				}
			}
		}
		if (!empty($statusMessage)) {
			$this->errorMsg .= $statusMessage;
		}
	}
	
	function _getSubDirs($directory) {
		global $_PATHCONFIG;
		
		$arrDirectories = array();
		
		$directoryPath = $_PATHCONFIG['ascms_root'].$_PATHCONFIG['ascms_root_offset'].$directory;
		
		$fp = @opendir($directoryPath);
		if ($fp) {
			while ($file = readdir($fp)) {
				$path = $directoryPath.DIRECTORY_SEPARATOR.$file;
				
				if ($file != "." && $file != "..") {
					array_push($arrDirectories, $directory.DIRECTORY_SEPARATOR.$file);
				
					if (is_dir(realpath($path))) {
						$arrDirectoriesRec = $this->_getSubDirs($directory.DIRECTORY_SEPARATOR.$file);
						if (count($arrDirectoriesRec)>0) {
							$arrDirectories = array_merge($arrDirectories, $arrDirectoriesRec);
						}
					}
				}
			}
			closedir($fp);
		}
		return $arrDirectories;
	}
	
	function isWindows() {
		if (substr(PHP_OS,0,3) == "WIN") {
			return true;
		} else {
			return false;
		}
	}
	
	function _chmod($file, $arrAttributes) {
		global $_FTPCONFIG, $_PATHCONFIG;
		
		if (!$this->isWindows() && $_FTPCONFIG['is_activated']) {
			// open ftp conneciton
			$objFtp = @ftp_connect($_FTPCONFIG['host'], $_FTPCONFIG['port'], 30);
			if ($objFtp) {
				// login to ftp server
				if (!@ftp_login($objFtp, $_FTPCONFIG['username'], $_FTPCONFIG['password'])) {
					@ftp_close($objFtp);
					return  "Die Authentifizierung mit dem angegebenen Benutzernamen und Passwort ist beim FTP-Server fehlgeschlagen!<br />";
				}
			} else {
				return "Kann keine Verbindung zum FTP-Server aufbauen!<br />";
			}
			
			if (phpversion()>=5) {
				// if system supports php5
				if (@ftp_chmod($objFtp, $arrAttributes['mode_oct'], $_FTPCONFIG['path'].$_PATHCONFIG['ascms_root_offset'].$file)) {
					return true;
				} else {
					return 'Konnte die Berechtigungen nicht ndern: '.$file."<br />";
				}
			} else {
				// if system don't support php5 yet
				$chmodCmd = "CHMOD ".$arrAttributes['mode']." ".$_FTPCONFIG['path'].$_PATHCONFIG['ascms_root_offset'].$file;
				if (@ftp_site($objFtp, $chmodCmd)) {
					return true;
				} else {
					return 'Konnte die Berechtigungen nicht ndern: '.$file."<br />";
				}
			}
		} else {
			if (@chmod($_PATHCONFIG['ascms_root'].$_PATHCONFIG['ascms_root_offset'].$file, $arrAttributes['mode_oct'])) {
				return true;
			} else {
				return 'Konnte die Berechtigungen nicht ndern: '.$file."<br />";
			}
		}
	}
	
	function _migratePermissionSystem() {
		global $objDatabase;
		
		$dynamic_right_id = 1;
		
		// check if the update has already been executed
		$arrTables = $objDatabase->MetaTables('TABLES');
		if ($arrTables === false) {
			$this->errorMsg .= "Es konnte nicht berprft werden, ob das Zugriff- und Rechtesystem aktualisiert werden muss!<br />";
			$this->errorMsg .= "Datenbank Meldung: <i>".$objDatabase->ErrorMsg()."</i><br />";
			return false;
		}
		
		
		// ***************************************************************************
		// update backend_areas table
		// ***************************************************************************
		
		$arrColumns = $objDatabase->MetaColumnNames($this->oldPrefix."backend_areas");
		if (!in_array('access_id', $arrColumns)) {
			if ($objDatabase->Execute("ALTER TABLE `".$this->oldPrefix."backend_areas` ADD `access_id` INT( 11 ) UNSIGNED NOT NULL") !== false) {
				
				$objResult = $objDatabase->Execute("SELECT area_id FROM ".$this->oldPrefix."backend_areas");
				
				if ($objResult !== false) {
					while (!$objResult->EOF) {
						$objDatabase->Execute("UPDATE ".$this->oldPrefix."backend_areas SET access_id=".$objResult->fields['area_id']." WHERE area_id=".$objResult->fields['area_id']);
						$objResult->MoveNext();
					}
				}
			} else {
				$this->errorMsg .= "Fehler beim Modifizieren der Tabelle '".$this->oldPrefix."backend_areas'!<br />";
				$this->errorMsg .= "Datenbank Meldung: <i>".$objDatabase->ErrorMsg()."</i><br />";
			}
		}
		
		
		// ***************************************************************************
		// create table group_static_rights
		// ***************************************************************************
		
		if (!in_array($this->oldPrefix."access_group_static_ids", $arrTables)) {
			if ($objDatabase->Execute("CREATE TABLE `".$this->oldPrefix."access_group_static_ids` (
					`access_id` INT( 11 ) UNSIGNED NOT NULL ,
					`group_id` INT( 11 ) UNSIGNED NOT NULL
					)") === false) {
				$this->errorMsg .= "Das Zugriff- und Rechtesystem konnte nicht erneuert werden!<br />";
				$this->errorMsg .= "Datenbank Meldung: <i>".$objDatabase->ErrorMsg()."</i><br />";
				return false;
			}
			
			$objResult = $objDatabase->Execute("SELECT group_id, area_ids FROM ".$this->oldPrefix."group_backend_permissions");
			
			if ($objResult !== false) {
				while (!$objResult->EOF) {
					
					$arrAreaIds = explode(",", $objResult->fields['area_ids']);
					
					foreach ($arrAreaIds as $id) {
						if ($id != 0) {
							$objDatabase->Execute("INSERT INTO ".$this->oldPrefix."access_group_static_ids (`access_id`, `group_id`) VALUES (".$id.", ".$objResult->fields['group_id'].")");
						}
					}
					
					$objResult->MoveNext();
				}
				
				$objDatabase->Execute("DROP TABLE ".$this->oldPrefix."group_backend_permissions");
			}
		}
		
		// ***************************************************************************
		// create table group_dynamic_right
		// ***************************************************************************
		
		if (!in_array($this->oldPrefix."access_group_dynamic_ids", $arrTables)) {
			
			if ($objDatabase->Execute("CREATE TABLE `".$this->oldPrefix."access_group_dynamic_ids` (
					`access_id` INT( 11 ) UNSIGNED NOT NULL ,
					`group_id` INT( 11 ) UNSIGNED NOT NULL
					)") === false) {
			$this->errorMsg .= "Das Zugriff- und Rechtesystem konnte nicht erneuert werden!<br />";
			$this->errorMsg .= "Datenbank Meldung: <i>".$objDatabase->ErrorMsg()."</i><br />";
			}
			
			$objResult = $objDatabase->Execute("SELECT catid, frontend_groups, backend_groups FROM ".$this->oldPrefix."content_navigation WHERE frontend_groups != '' OR backend_groups!=''");
			
			if ($objResult !== false) {
				while (!$objResult->EOF) {
					if (!empty($objResult->fields['frontend_groups'])) {
						$arrContentNavigation[$objResult->fields['catid']]['frontend'] = explode(",",$objResult->fields['frontend_groups']);
					}
					if (!empty($objResult->fields['backend_groups'])) {
						$arrContentNavigation[$objResult->fields['catid']]['backend'] = explode(",",$objResult->fields['backend_groups']);
					}
					$objResult->MoveNext();
				}
				
				$objDatabase->Execute("ALTER TABLE `".$this->oldPrefix."content_navigation` DROP `frontend_groups`");
				$objDatabase->Execute("ALTER TABLE `".$this->oldPrefix."content_navigation` DROP `backend_groups`");
				$objDatabase->Execute("ALTER TABLE `".$this->oldPrefix."content_navigation` ADD `frontend_access_id` INT( 11 ) UNSIGNED NOT NULL AFTER `protected`");
				$objDatabase->Execute("ALTER TABLE `".$this->oldPrefix."content_navigation` ADD `backend_access_id` INT( 11 ) UNSIGNED NOT NULL AFTER `frontend_access_id`");
				
				if (is_array($arrContentNavigation)) {
					foreach ($arrContentNavigation as $id => $arrGroups) {
						if (isset($arrGroups['frontend'])) {
							foreach ($arrGroups['frontend'] as $groupId) {
								$objDatabase->Execute("INSERT INTO ".$this->oldPrefix."access_group_dynamic_ids (`access_id`,`group_id`) VALUES (".$dynamic_right_id.", ".$groupId.")");
							}
							$objDatabase->Execute("UPDATE ".$this->oldPrefix."content_navigation SET frontend_access_id=".$dynamic_right_id." WHERE catid=".$id);
							$dynamic_right_id++;
						}
						
						if (isset($arrGroups['backend'])) {
							foreach ($arrGroups['backend'] as $groupId) {
								$objDatabase->Execute("INSERT INTO ".$this->oldPrefix."access_group_dynamic_ids (`access_id`,`group_id`) VALUES (".$dynamic_right_id.", ".$groupId.")");
							}
							$objDatabase->Execute("UPDATE ".$this->oldPrefix."content_navigation SET backend_access_id=".$dynamic_right_id." WHERE catid=".$id);
							$dynamic_right_id++;
						}
					}
				}
				
				$objDatabase->Execute("INSERT INTO ".$this->oldPrefix."settings (`setname`,`setvalue`,`setmodule`) VALUES ('lastAccessId', ".$dynamic_right_id.", 1)");
			}
		}
		
		if (!in_array($this->oldPrefix."access_users", $arrTables)) {
			$objDatabase->Execute("ALTER TABLE `".$this->oldPrefix."users` RENAME `".$this->oldPrefix."access_users`");
		}
		if (!in_array($this->oldPrefix."access_user_groups", $arrTables)) {
			$objDatabase->Execute("ALTER TABLE `".$this->oldPrefix."user_groups` RENAME `".$this->oldPrefix."access_user_groups`");
		}
	}
}
?>
</form>
</body>
</html>