<?php
/**
* Skins class
*
* Skins and Themes management functions
*
* @copyright	CONTREXX CMS - Astalavista IT Engineering GmbH Thun
* @author		Astalavista Development Team <thun@astalvista.ch>
* @access		public
* @module		settings
* @modulegroup	core
* @version		1.0.0
*/ 

require_once ASCMS_LIBRARY_PATH . '/FRAMEWORK/File.class.php';


class skins
{
	var $pageTitle;                        // var for the title of the active page
	var $statusMessage;                    // var for the status message
	
	var $arrPaths;                         // array paths
	var $arrWebPaths;                      // array web paths
	
	var $getAct;                           // $_GET['act']
	var $getPath;                          // $_GET['path']
	
	var $path;                             // current path
	var $folderName;                       // Folder Name 
	var $dirLog;                           // Dir Log
	var $webPath;                          // current web path
	
	var $tableExists;                      // Table exists
	var $oldTable;                         // old Theme-Table name
	
	var $filenames = array("index.html","content.html","home.html","navbar.html","subnavbar.html","sidebar.html","shopnavbar.html","headlines.html","javascript.js","style.css","buildin_style.css",);
	var $fileextensions = array("html", "txt", "css", "js", "htm", "php", "java", "tpl", "xml");
	
	
	
	/**
    * Constructor
    *
    * @param  string  
    * @access public
    */
    function skins(){ 
    	global  $_CORELANG, $_FTPCONFIG, $objTemplate, $objDatabase;
        
		// get path variables                            
	    $this->arrWebPaths  = array(ASCMS_THEMES_WEB_PATH.'/');
	    $this->arrPaths  = array(ASCMS_THEMES_PATH. '/');
	    $this->path = ASCMS_THEMES_PATH. '/';	    
	    
	    $this->webPath = $this->arrWebPaths[0];
	    
	    if(substr($this->webPath, -1) != '/'){
            $this->webPath = $this->webPath . '/';
        }

	    $objTemplate->setVariable("CONTENT_NAVIGATION",
	                       "<a href='index.php?cmd=skins'>[".$_CORELANG['TXT_DESIGN_OVERVIEW']."]</a>
	                       <a href='index.php?cmd=skins&amp;act=newDir'>[".$_CORELANG['TXT_NEW_DESIGN']."]</a>
	                       <a href='index.php?cmd=skins&amp;act=activate'>[".$_CORELANG['TXT_ACTIVATE_DESIGN']."]</a>
	                       <a href='index.php?cmd=media&amp;archive=themes'>[".$_CORELANG['TXT_DESIGN_FILES_ADMINISTRATION']."]</a>
                           <a href='index.php?cmd=skins&amp;act=examples'>[".$_CORELANG['TXT_DESIGN_REPLACEMENTS_DIR']."]</a>");                 
	                       
	    $objDatabase->Execute("OPTIMIZE TABLE ".DBPREFIX."skins");  
    	$this->oldTable = DBPREFIX."themes";
    	
    	$obj_file = &new File();
        $obj_file->setChmod($this->path, $this->webPath, "");
    }

    
    
    /**
    * Gets the requested methods
    *   
    * @global	 array     $_CORELANG
    * @return    string    parsed content                                                                               
    */
    function getPage(){
    	global $_CORELANG, $objTemplate, $objPerm;
    	
    	if(!isset($_GET['act'])) {
    	    $_GET['act']="";	
    	}
    	
        switch($_GET['act']){
			case "activate":			     
			    $objPerm->checkAccess(46, 'static');		     
			    $this->activate();       	
			break;		
			case "examples":
			    $objPerm->checkAccess(47, 'static');		     
			    $this->examples();      	
			break;	
			case "upload":
			    $objPerm->checkAccess(47, 'static');		     
			    $this->upload(); 
			    $this->overview();      	
			break;		
			case "update":
			    $objPerm->checkAccess(47, 'static');		     
			    $this->update();   
			    $this->overview();    	
			break;	
			case "newDir":
			    $objPerm->checkAccess(47, 'static');		     
			    $this->newdir();      	
			break;	
			case "createDir":
				$objPerm->checkAccess(47, 'static');	
				$this->createdir();
				//$this->overview();
			break;	
			case "newFile":
			    $objPerm->checkAccess(47, 'static');		     
			    $this->newfile(); 
			    $this->overview();      	
			break;															    								
			default:
			    $objPerm->checkAccess(47, 'static');            
			    $this->newfile();  
			    $this->delfile();    
			    $this->deldir(); 
			    $this->overview();   		        
		}
		$objTemplate->setVariable(array(
			'CONTENT_TITLE'				=> $this->pageTitle,
			'CONTENT_STATUS_MESSAGE'	=> $this->statusMessage
		));
    }
    
    
    /**
    * skinsOverview
    *
    * @access   public
    */
    function overview(){ 
		global $_CONFIG, $_CORELANG, $objTemplate;
		
	    // initialize variables	
		$objTemplate->addBlockfile('ADMIN_CONTENT', 'skins_content', 'skins_content.html');
		$this->pageTitle = $_CORELANG['TXT_OVERVIEW']; 
		$objTemplate->setVariable(array(
		    'TXT_CHOOSE_TEMPLATE_GROUP'       =>     $_CORELANG['TXT_CHOOSE_TEMPLATE_GROUP'], 
		    'TXT_SELECT_FILE'                 =>     $_CORELANG['TXT_SELECT_FILE'],
		    'TXT_DESIGN_FOLDER'               =>     $_CORELANG['TXT_DESIGN_FOLDER'], 
		    'TXT_TEMPLATE_FILES'              =>     $_CORELANG['TXT_TEMPLATE_FILES'], 
		    'TXT_FILE_EDITOR'                 =>     $_CORELANG['TXT_FILE_EDITOR'],
		    'TXT_UPLOAD_FILES'    	    	  => 	 $_CORELANG['TXT_UPLOAD_FILES'],
    	    'TXT_CREATE_FILE'  				=> $_CORELANG['TXT_CREATE_FILE'],
    	    'TXT_DELETE'               		  =>     $_CORELANG['TXT_DELETE'],
    	    'TXT_STORE'               		  =>     $_CORELANG['TXT_STORE'],
    	    'TXT_RESET'               		  =>     $_CORELANG['TXT_RESET'],
    	    'TXT_SELECT_ALL'                  =>     $_CORELANG['TXT_SELECT_ALL'],
    	    'TXT_MANAGE_FILES'                =>     $_CORELANG['TXT_MANAGE_FILES'],
    	    'TXT_SELECT_THEME'                =>     $_CORELANG['TXT_SELECT_THEME'],	
    	    'TXT_THEME_NAME'                  =>     $_CORELANG['TXT_THEME_NAME'],
    	    'TXT_DESIGN_OVERVIEW'             =>     $_CORELANG['TXT_DESIGN_OVERVIEW'],
    	    'TXT_MODE'						  =>     $_CORELANG['TXT_MODE'],
    	    'TXT_STRIPSLASHES'					=>   "Stripslashes"
		));
		
		$this->getDropdownContent();
    }
      
    
    
    /**
    * Gets the themes assigning page
    *
    * @access   public
    * @global   object   $objDatabase
    * @param    string   $page_content
    * @return   string   parsed content
    */
	function activate()
    { 
		global $_CONFIG, $objDatabase, $_CORELANG, $objTemplate;
		
		$objTemplate->addBlockfile('ADMIN_CONTENT', 'skins_active', 'skins_activate.html');
		$this->pageTitle = $_CORELANG['TXT_ACTIVATE_DESIGN']; 		
		$objTemplate->setVariable(array(
		    'TXT_ACTIVATE_DESIGN'      => $_CORELANG['TXT_ACTIVATE_DESIGN'],
		    'TXT_ID'                   => $_CORELANG['TXT_ID'],
		    'TXT_LANGUAGE'             => $_CORELANG['TXT_LANGUAGE'],
		    'TXT_ACTIVE_TEMPLATE'      => $_CORELANG['TXT_ACTIVE_TEMPLATE'],
		    'TXT_ACCEPT_ALLOCATION'    => $_CORELANG['TXT_ACCEPT_ALLOCATION']
		));
		$i=0;

		if(isset($_POST['themesId'])) {
			foreach ($_POST['themesId'] as $langid => $themesId) {
			    $objDatabase->Execute("UPDATE ".DBPREFIX."languages SET themesid='".intval($themesId)."' WHERE id=".intval($langid));
			}
		}
				
		$objResult = $objDatabase->Execute("SELECT id,lang,name,themesid FROM ".DBPREFIX."languages ORDER BY id");
		if ($objResult !== false) {
			while (!$objResult->EOF) {
				if (($i % 2) == 0) {$class="row1";} else {$class="row2";}
				$objTemplate->setVariable(array(
					'THEMES_ROWCLASS'			=> $class,
					'THEMES_LANG_ID'			=> $objResult->fields['id'],
					'THEMES_LANG_SHORTNAME'		=> $objResult->fields['lang'],
					'THEMES_LANG_NAME'			=> $objResult->fields['name'],
					'THEMES_TEMPLATE_MENU'		=> $this->getDropdownActivated($objResult->fields['themesid'])
				));
				$objTemplate->parse('themesLangRow');
				$i++;
				$objResult->MoveNext();
			}
		}
	}
	
	
	/**
    * Gets the themes exampele page
    *
    * @access   public
    */
    function examples()
    { 
		global $_CONFIG, $_CORELANG, $objTemplate;
		
	    // initialize variables	
		$objTemplate->addBlockfile('ADMIN_CONTENT', 'skins_examples', 'skins_examples.html');
		$this->pageTitle = $_CORELANG['TXT_DESIGN_VARIABLES_LIST'];	
		$objTemplate->setVariable(array(		    
		    'TXT_STANDARD_TEMPLATE_STRUCTURE' => $_CORELANG['TXT_STANDARD_TEMPLATE_STRUCTURE'], 
		    'TXT_STARTPAGE'                   => $_CORELANG['TXT_STARTPAGE'], 
		    'TXT_STANDARD_PAGES'              => $_CORELANG['TXT_STANDARD_PAGES'],
		    'TXT_REPLACEMENT_LIST'            => $_CORELANG['TXT_REPLACEMENT_LIST'],			    
		    'TXT_FILES'                       => $_CORELANG['TXT_FILES'],
		    'TXT_CONTENTS'                    => $_CORELANG['TXT_CONTENTS']
		)); 
    }
    
    /**
    * create skin folder page
    *
    * @access   public
    */
    function newdir()
    { 
		global $_CONFIG, $_CORELANG, $objTemplate;
		
	 	$this->webPath = $this->arrWebPaths[0];
	 	
		// initialize variables	
		$objTemplate->addBlockfile('ADMIN_CONTENT', 'skins_create', 'skins_create.html');
		$this->pageTitle = $_CORELANG['TXT_NEW_DIRECTORY'];	
		
		$obj_file = new File();
		$test=$obj_file->checkConnection();		
		
		$objTemplate->setVariable(array(
		    'TXT_NEW_DIRECTORY'       => $_CORELANG['TXT_NEW_DIRECTORY'],
		    'TXT_EXISTING_DIR_NAME'   => $_CORELANG['TXT_EXISTING_DIR_NAME'],
    	    'CREATE_DIR_ACTION'       => '?cmd=skins&amp;act=createDir&amp;path=' . $this->webPath,
    	    'TXT_DIR_NAME'            => $_CORELANG['TXT_DIR_NAME'],
    	    'TXT_DB_NAME'             => $_CORELANG['TXT_DB_NAME'],
    	    'TXT_DESCRIPTION'         => $this->webPath,
    	    'TXT_SELECT_DIR'          => $_CORELANG['TXT_SELECT_DIR'],
    	    'TXT_CREATE'              => $_CORELANG['TXT_CREATE'],	
    	    'TXT_FROM_TEMPLATE'       => $_CORELANG['TXT_FROM_TEMPLATE'],
    	    'THEMES_TEMPLATE_MENU'	  => $this->getThemesDropdown(""),
    	    'TXT_FTP_STATUS'  	      => $test
		)); 
		
		$objTemplate->setVariable('THEMES_MENU', $this->getDropdownNotInDb());
		$this->checkTable($this->oldTable);
    }
    
    
     
    /**
    * create skin folder 
    *
    * @access   public
    */
    function createdir()
    { 
		global $_CONFIG, $_CORELANG, $objTemplate;
		
		if($_POST['dbName'] != "") {
			if(($_POST['dirName']!= "") && ($_POST['existingdirName'] == "")) {
		    	
				$dirName = $this->replaceCharacters($_POST['dirName']);		    
	        	
		    	$obj_file = new File();
		    	
    			if($_POST['fromTheme'] == "" && $_POST['fromDB'] == "") {
        			$this->dirLog=$obj_file->mkDir($this->path, $this->webPath, $dirName);
        			if($this->dirLog != "error") {
        				$this->insertIntoDb($_POST['dbName'], $this->dirLog, $_POST['fromDB']);
    					$this->createDefaultFiles($this->dirLog);
        			}
        		} elseif($_POST['fromTheme'] != "" && $_POST['fromDB'] == "") {
        			$this->dirLog=$obj_file->copyDir($this->path, $this->webPath, $_POST['fromTheme'], $this->path, $this->webPath, $dirName);
        			if($this->dirLog != "error") {
        				$this->insertIntoDb($_POST['dbName'], $this->dirLog, $_POST['fromDB']);
        			}
        		} elseif($_POST['fromTheme'] == "" && $_POST['fromDB'] != "") {
        			$this->dirLog=$obj_file->mkDir($this->path, $this->webPath, $dirName);
        			if($this->dirLog != "error") {
        				$this->insertIntoDb($_POST['dbName'], $this->dirLog, $_POST['fromDB']);
    					$this->createFilesFromDB($this->dirLog, intval($_POST['fromDB']));
        			}
        		}
	        	
			} elseif(($_POST['dirName'] == "") && ($_POST['existingdirName'] != "")) {
				$this->insertIntoDb($_POST['dbName'], $_POST['existingdirName']); 	
				$this->setChmodDir($_POST['existingdirName']);
				$status = $_POST['existingdirName']." ". $_CORELANG['TXT_STATUS_SUCCESSFULLY_CREATE'];
				$this->statusMessage  = $status;
			} else {
				$this->statusMessage = $_CORELANG['TXT_STATUS_CHECK_INPUTS'];
			}
		} else {
			$this->statusMessage = $_CORELANG['TXT_STATUS_CHECK_INPUTS'];
		}
    }
    
    
    /**
    * sets all CHMOD for Files and folder ind this directory
    *
    * @access   public
    * @string   $dir
    */
    function setChmodDir($dir)
	{
		$obj_file = &new File();
        $obj_file->setChmod($this->path, $this->webPath, $dir);
		
		$openDir=@opendir($this->path.$dir);
		while ($file=@readdir($openDir)) {
			if($file!="." && $file!="..") {
				if(!is_dir($this->path.$dir."/".$file)) {
					$obj_file->setChmod($this->path, $this->webPath, $dir."/".$file);
				} else {
					$this->setChmodDir($dir."/".$file);
				}
			}
		}
	    closedir($openDir);
	}
    
    
    
    /**
    * Gets the dir dropdown menu witch are not in the DB
    *
    * @access   public
    * @global   object   $objDatabase
    * @return   string   $nadm
    */
	function getDropdownNotInDb()
	{
		global $_CONFIG, $objDatabase, $_CORELANG;
		
		$activatedThemes = array();
		
		$objResult = $objDatabase->Execute("SELECT id,foldername FROM ".DBPREFIX."skins ORDER BY id");
		$i=0;
		if ($objResult !== false) {
			while (!$objResult->EOF) {
				$activatedThemes[$i] = $objResult->fields['foldername'];
				$i++;
				$objResult->MoveNext();
			}
		}
		
		$dir = ($this->path);
				
		$dh=opendir($dir);
		while ($file=readdir($dh)) {
			if($file!="." && $file!=".." && $file != "zip") {	
				if(!in_array($file, $activatedThemes)) {
					$selected="";		
					$nadm .="<option value='".$file."' $selected>".$file."</option>\n";
				}
			}
		}
		closedir($dh);
		
		return $nadm;
	}
	
	
    
    /**
    * upload skin file
    *
    * @access   public
    * @param    string   $themes
    */
    function upload()
    { 
		global $_CONFIG, $_CORELANG;
		   
		// initialize variables	
    	$this->statusMessage = 'Upload noch nicht implementiert.';
    }
    
    
    
    /**
    * export skin themes 
    *
    * @access   public
    * @param    string   $themes
    */
    function exportFile($theme)
    { 
		global $_CONFIG, $_CORELANG;
		
		$archive = new PclZip($this->path.'zip/'.$theme.'.zip');
        $v_list = $archive->add($this->path.$theme, PCLZIP_OPT_REMOVE_PATH, $this->path.'/'.$theme.'/');
        
  		$link = $this->webPath.'zip/'.$theme.'.zip';

		return $link;

    }
    
    
    
    /**
    * update skin file
    *
    * @access   public
    */
    function update(){ 
		
	    $themes = $_POST['themes'];
	    $themesPage = $_POST['themesPage'];
	    $pageContent = $_POST['content'];	
	    
	    if(isset($_POST['stripslashes']) AND  $_POST['stripslashes'] == 1){
	    	$pageContent = stripslashes($pageContent);    
	    }	    
	    
	    // Change the replacement variables from [[TITLE]] into {TITLE}
	    $pageContent = preg_replace('/\[\[([A-Z0-9_]*?)\]\]/', '{\\1}' ,$pageContent);		
	    
		if(!$fp = @fopen($this->path.$themes."/".$themesPage ,"w")){	
			$this->setChmodDir($themes);
		}
		
		$fp = fopen ($this->path.$themes."/".$themesPage ,"w");
		fwrite($fp, $pageContent);
		fclose($fp);  
    }
    
    
    
    /**
    * insert Skin into DB 
    *
    * @global   object   $objDatabase
    * @param    string   $path 
    * @param    string   $folder
    * @param    string   $themesname
    * @access   public
    */
    function insertIntoDb($themesName, $themesFolder, $oldId="") { 
		global  $objDatabase;
		
		if(($themesName != "") && ($themesFolder != "")) {
			$objDatabase->Execute("INSERT INTO ".DBPREFIX."skins (themesname, foldername, expert) VALUES ('".addslashes(strip_tags($themesName))."','".addslashes(strip_tags($themesFolder))."', '1')");
			$newId = $objDatabase->Insert_ID();
			
			$objDatabase->Execute("UPDATE ".DBPREFIX."content_navigation 
			                          SET themes_id='".intval($newId)."' 
			                        WHERE themes_id='".intval($oldId)."' 
			                          AND themes_id!='0';");			
			// initialize variables	
			$this->newdir();
		}
    }
    
    
    
    /**
    * add new skin file
    *
    * @access   public
    */
    function newfile()
    { 
		global $_CONFIG, $_CORELANG;
		 
		$themes = $_POST['themes'];
        
        $themesFile = $this->replaceCharacters($_POST['themesNewFileName']);
			
        if(($themesFile!="") AND ($themes!="")) {
			$fp = fopen ($this->path.$themes."/".$themesFile ,"w");
			fwrite($fp,"");
			fclose($fp);
	  	
			// initialize variables	
			$this->statusMessage = $themesFile." ".$_CORELANG['TXT_STATUS_SUCCESSFULLY_CREATE'];
        }	       	
    }
    
    
    
    /**
    * del skin file
    *
    * @access   public
    */
    function delfile(){ 
		global $_CONFIG, $_CORELANG;
		
		$themesFile = $_POST['themesDelFileName']; 
		$themes = $_POST['themes'];
			
        if(($themesFile!="") AND ($themes!="")){
        	if($_POST['themesPage'] != $themesFile) {    		
        		$obj_file = new File();
		    	$this->dirLog = $obj_file->delFile($this->path, $this->webPath, $themes."/".$themesFile);

		    	if($this->dirLog != "error") {
					$this->statusMessage = $themesFile." ".$_CORELANG['TXT_STATUS_SUCCESSFULLY_DELETE'];
		    	}
             } else {
             	$this->statusMessage = $_CORELANG['TXT_STATUS_FILE_CURRENTLY_OPEN']; 
             }
        }     	
    }
    
    
    
    /**
    * del skin folder and all files in it
    *
    * @access   public
    * @global   object   $objDatabase
    */
    function deldir()
    { 
		global $_CONFIG, $objDatabase, $_CORELANG;
		
		$themes = $_POST['themesDelName'];
			
        if($themes!="") {
        	if($_POST['themes'] != $themes) {
				$dir = ($this->path.$themes);
		    	if(file_exists($dir)) {
					
		    		//del hole folder with subfolders
		    		$obj_file = new File();
    				$this->dirLog = $obj_file->delDir($this->path, $this->webPath, $themes);
	   
	   				if($this->dirLog != "error") {
	   					$objResult = $objDatabase->Execute("SELECT id FROM ".DBPREFIX."skins WHERE foldername = '".$themes."'");
	   					if ($objResult !== false) {
		   					while (!$objResult->EOF) {
								$themesId = $objResult->fields['id'];
								$objResult->MoveNext();
							}
	   					}
						$objDatabase->Execute("UPDATE ".DBPREFIX."content_navigation SET themes_id ='0' WHERE themes_id = '".$themesId."'");
	   					$objDatabase->Execute("DELETE FROM ".DBPREFIX."skins WHERE foldername = '".$themes."'");
	   					$this->statusMessage = $themes." ".$_CORELANG['TXT_STATUS_SUCCESSFULLY_DELETE'];
				   	} else {
						$this->statusMessage = $themes." ".$_CORELANG['TXT_STATUS_CANNOT_DELETE'];
				   	}
		    	} else {
		    		$objResult = $objDatabase->Execute("SELECT id FROM ".DBPREFIX."skins WHERE foldername = '".$themes."'");
		    		if ($objResult !== false) {
	   					while (!$objResult->EOF) {
							$themesId = $objResult->fields['id'];
							$objResult->MoveNext();
						}
		    		}
					$objDatabase->Execute("UPDATE ".DBPREFIX."content_navigation SET themes_id ='0' WHERE themes_id = '".$themesId."'");
   					$objDatabase->Execute("DELETE FROM ".DBPREFIX."skins WHERE foldername = '".$themes."'");
   					$this->statusMessage = $themes." ".$_CORELANG['TXT_STATUS_SUCCESSFULLY_DELETE'];
					$this->statusMessage = $themes." ".$_CORELANG['TXT_STATUS_SUCCESSFULLY_DELETE'];
		    	}
             } else {
             	$this->statusMessage = $_CORELANG['TXT_STATUS_FILE_CURRENTLY_OPEN']; 
             }
        }     	
    }
    
    
    /**
    * Gets the dropdown menus content
    *
    * @access public
    */
	function getDropdownContent() {
		global $objTemplate;		
		$objTemplate->setVariable(array(
			'THEMES_PAGES_MENU'		=> $this->getFilesDropdown($_POST['themes'], $_POST['themesPage']),
			'THEMES_MENU'			=> $this->getThemesDropdown($_POST['themes']),
			'THEMES_PAGE_VALUE'		=> $this->getFilesContent($_POST['themes'], $_POST['themesPage']),
			'THEMES_PAGE_DEL_VALUE'	=> $this->getFilesDropdownDel($_POST['themes']),
			'THEMES_MENU_DEL'		=> $this->getThemesDropdownDel()
		));
	}
	
	
	
	/**
    * Gets the activated themes dropdown menu
    *
    * @access   public
    * @param    string   $themes (optional)
    * @return   string   $atdm
    */
	function getDropdownActivated($themesId)
	{
		global $_CONFIG, $_CORELANG;
		
		$objDb2 = getDatabaseObject($this->statusMessage, true);
		if ($objDb2 !== false) {
			$objResult = $objDb2->Execute("SELECT id,themesname FROM ".DBPREFIX."skins ORDER BY id");		
			if ($objResult !== false) {
				while (!$objResult->EOF) {				
					$selected="";
					if ($objResult->fields['id'] == intval($themesId))	$selected = "selected";							
					$atdm .="<option value='".$objResult->fields['id']."' $selected>".$objResult->fields['themesname']."</option>\n";
					$objResult->MoveNext();
				}
			}
			return $atdm;
		} else {
			return '';
		}
	}
      
    
	
	/**
    * Gets the themes dropdown menu
    *
    * @access   public
    * @global   object   $objDatabase
    * @param    string   $themes (optional)
    * @return   string   $tdm
    */
	function getThemesDropdown($themes)
	{
		global $_CONFIG, $objDatabase, $_CORELANG;
		
		if(!isset($themes)) {
            $themes = $this->selectTheme();
		}
		
		$defaultTheme = $this->selectTheme();
		
		$objResult = $objDatabase->Execute("SELECT id,themesname,foldername FROM ".DBPREFIX."skins ORDER BY id");
		if ($objResult !== false) {
			while (!$objResult->EOF) {
				$selected="";
				$default = "";
				if($objResult->fields['foldername'] == $defaultTheme) $default = "(".$_CORELANG['TXT_DEFAULT'].")";	
				if($themes == $objResult->fields['foldername']) $selected = "selected";	
				$tdm .="<option value='".$objResult->fields['foldername']."' $selected>".$objResult->fields['themesname']." ".$default."</option>\n";	
				$objResult->MoveNext();
			}
		}
		return $tdm;
	}
	
	
	
	/**
    * Gets the themes dropdown menu
    *
    * @access   public
    * @global   object   $objDatabase
    * @param    string   $themes (optional)
    * @return   string   $tdm
    */
	function getThemesDropdownDel()
	{
		global $_CONFIG, $objDatabase, $_CORELANG;
		$activatedThemes = array();
		
		$objResult = $objDatabase->Execute("SELECT id,themesid,is_default FROM ".DBPREFIX."languages ORDER BY id");
		$i=0;
		if ($objResult !== false) {
			while (!$objResult->EOF) {
				$activatedThemes[$i] = $objResult->fields['themesid'];
				$i++;
				$objResult->MoveNext();
			}
		}
		
		$objResult = $objDatabase->Execute("SELECT id,themesname,foldername FROM ".DBPREFIX."skins ORDER BY id");
		if ($objResult !== false) {
			while (!$objResult->EOF) {
				if(!in_array($objResult->fields['id'], $activatedThemes)) {
					$selected="";
					$tdm .="<option value='".$objResult->fields['foldername']."'>".$objResult->fields['themesname']."</option>\n";
				}
				$objResult->MoveNext();
			}
		}
		
		return $tdm;
	}
	
	
	/**
    * Gets the themes pages dropdown menu
    *
    * @access   public
    * @param    string   $themes
    * @param    string   $themesPage (optional)
    * @return   string   $fdm
    */
	function getFilesDropdown($themes="", $themesPage="")
	{
		global $_CONFIG, $_CORELANG;
		
		if(!isset($themes)) {
            $themes = $this->selectTheme();
		}
		
		if(!isset($themesPage)) {
            $themesPage = "index.html";
		}
		
		$defaultFiles = array();
		
		if($themes != "") {
	    	$file = $this->path.$themes;
	    	if(file_exists($file)) {
				$skin_folder_page = opendir ($file);
				while ($page = readdir ($skin_folder_page)) {
			    	$extension = split("[.]",$page);
			    	$x = count($extension)-1; 
			    	
			    	if(in_array($extension[$x], $this->fileextensions))	{
				    	if(in_array($page, $this->filenames)) {
					     	if($page != "." && $page != "..") {						
								$defaultFiles[] = $page;
						    } 
						} else {
							if($page != "." && $page != "..") {
				            	$selected="";
								if($themesPage==$page) $selected = "selected";							
								$special .="<option value='".$page."' $selected>".$page."</option>\n";	
						    }
						}
					}
		        }
		        closedir($skin_folder_page); 
		        
		        //sort files
		        sort($defaultFiles);
		        foreach ($defaultFiles as $id => $page){
		        	$selected="";
		        	if($themesPage==$page) $selected = "selected";
					$default .="<option value='".$page."' $selected>".$page."</option>\n";
		        }
		        
		        //create dropdown
		        $seperator = "<option value=''>----------------------------------------</option>\n";		        
		        $fdm =$default.$seperator.$special;
        	} else {
	    		$this->statusMessage = $_CORELANG['TXT_STATUS_CANNOT_OPEN'];	    		
	    	}
		   
	    } else {
	    	$fdm .="<option value='1' $selected>".$_CORELANG['TXT_CHOOSE_DESIGN']."</option>\n";
	    	
	    }
	    return $fdm;
	}	
	
	
	
	/**
    * Gets the themes pages dropdown menu del
    *
    * @access   public
    * @return   string   $fdmd
    */
	function getFilesDropdownDel($themes="")
	{
		global $_CONFIG, $_CORELANG;
		
		if(!isset($themes)) {
            $themes = $this->selectTheme();
		}

		if($themes != "") {
			$file = $this->path.$themes;
	    	if(file_exists($file)) {
	    		$themesPage = opendir ($file);
				while ($page = readdir ($themesPage)) {
					$extension = split("[.]",$page);
			    	$x = count($extension)-1; 
			    	
			    	if(in_array($extension[$x], $this->fileextensions))	{
				     	if(($page != ".") && ($page != "..") && (!in_array($page, $this->filenames))) {						
							$fdmd .="<option value='".$page."' $selected>".$page."</option>\n";
					    }
			    	}
		        }
			    closedir($themesPage);
	    	}
		} else {
	    	$fdmd .="<option value='1' $selected>".$_CORELANG['TXT_CHOOSE_DESIGN']."</option>\n";
	    	
	    } 
	    return $fdmd;
	}
	
	
	/**
    * Gets the themes pages file content
    *
    * @access   public
    * @param    string   $themes
    * @param    string   $themesPage
    * @return   string   $fileContent
    */
	function getFilesContent($themes="", $themesPage=""){
		global $_CONFIG, $objDatabase, $_CORELANG, $objTemplate;
		
		if(!isset($themes)) {
            $themes = $this->selectTheme();
		}
		
		if(!isset($themesPage)) {
            $themesPage = "index.html";
		}
		
		if($themes != "" && $themesPage != ""){
	    	$file = $this->path.$themes.'/'.$themesPage;
	    	if(file_exists($file)) {
	    		   
				$contenthtml=file_get_contents($file);
				$contenthtml = preg_replace('/\{([A-Z0-9_]*?)\}/', '[[\\1]]' ,$contenthtml);
				$contenthtml = stripslashes($contenthtml);		
				$contenthtml = htmlspecialchars($contenthtml);										
				
				$objResult = $objDatabase->Execute("SELECT id,expert FROM ".DBPREFIX."skins WHERE foldername = '".$themes."'");
				if ($objResult !== false) {
					while (!$objResult->EOF) {
						$expert = $objResult->fields['expert'];
						$objResult->MoveNext();
					}
				}
				
				$objTemplate->setVariable(array(
				    'THEMES_SELECTED_THEME'         =>     $themes, 
				    'THEMES_SELECTED_PAGENAME'      =>     $themesPage,
				    'THEMES_FULL_PATH'              =>     $this->webPath.$themes.'/'.$themesPage,
				    'CONTENT_HTML'	 				=>     $contenthtml
				)); 												
				//return $fileContent;
	    	}
	    }
	}	
	
	/**
    * replaces some characters
    *
    * @access   public
    * @param    string   $themes
    */
    function replaceCharacters($string)
    {
    	global $_CONFIG, $_CORELANG;
    	
        // replace $change with ''
        $change = array('+', '', '"', '@', '*', '#', '', '%', '', '&', '', '/', '|', '(', '', ')', '=', '?', '\'', '', '`', '^', '~', '!', '', '[', ']', '{', '}', '', '$', '-', '<', '>', '\\', ';', ',', ':');
        // replace $signs1 with $signs
        $signs1 = array(' ', '', '', '', '');
        $signs2 = array('_', 'ae', 'oe', 'ue', 'c');
        
        $string = strtolower($string);
        foreach($change as $str) {
		    $string = str_replace($str, '', $string);
        }
        for($x = 0; $x < count($signs1); $x++) {
            $string = str_replace($signs1[$x], $signs2[$x], $string);
        }
        $string = str_replace('__', '_', $string);
        
        if(strlen($string) > 40) {
            $info       = pathinfo($string);
            $stringExt  = $info['extension'];
            
            $stringName = substr($string, 0, strlen($string) - (strlen($stringExt) + 1));
            $stringName = substr($stringName, 0, 40 - (strlen($stringExt) + 1));
            $string     = $stringName . '.' . $stringExt;
        }
        
        return $string;        
    }
    
    
    
    /**
    * if not isset themes
    *
    * @access   public
    * @return   string   $themes
    */
    function selectTheme()
    {
    	global $_CONFIG, $objDatabase, $_CORELANG;

    	$objResult = $objDatabase->Execute("SELECT id,themesid,is_default FROM ".DBPREFIX."languages WHERE is_default='true' ORDER BY id");
    	if ($objResult !== false) {
			while (!$objResult->EOF) {
				$themeId = $objResult->fields['themesid'];
				$objResult->MoveNext();
			}
    	}
		
		$objResult = $objDatabase->Execute("SELECT id,foldername FROM ".DBPREFIX."skins WHERE id=".$themeId." ORDER BY id");
		if ($objResult !== false) {
			while (!$objResult->EOF) {
				$themes = $objResult->fields['foldername'];
				$objResult->MoveNext();
			}
		}
		return $themes; 
    }
    
    /**
    * selectDefaultTheme
    *
    * @access   public
    * @return   string   $themes
    */
    function selectDefaultTheme()
    {
    	global $objDatabase;

    	$objResult = $objDatabase->Execute("SELECT id,themesid,is_default FROM ".DBPREFIX."languages WHERE is_default='true' ORDER BY id");
    	if ($objResult !== false) {
			while (!$objResult->EOF) {
				$themeId = $objResult->fields['themesid'];
				$objResult->MoveNext();
			}
    	}
		
		return $themeId; 
    }
    
    
    
    /**
    * create default themepages
    *
    * @access   public
    * @param    string   $themes
    */
    function createDefaultFiles($themes)
    {
    	for($x = 0; $x < count($this->filenames); $x++) {
            $fp = @fopen ($this->path.$themes."/".$this->filenames[$x] ,"w");
			@fwrite($fp,"");
			@fclose($fp);
        }
	    	
    }
    
    
    
    /**
    * check iftable exists
    *
    * @access   public
    * @param    string   $table
    */
    function checkTable($table)
    {	
	    global $_CONFIG, $objDatabase, $_CORELANG;	    
		$arrTables = array();		
		// get tables in database
		$arrTables = $objDatabase->MetaTables('TABLES');
		if ($arrTables !== false) {
			if(in_array($table, $arrTables)) {
				$this->tableExists = "tblexists";
				$this->getDbDropdown($table);
				$this->dropTable($this->oldTable);	
			}
		}
    }
    
    
    
    /**
    * create db themes dropdownmenu
    *
    * @access   public
    * @param    string   $table
    */
    function getDbDropdown()
    {	
	    global $objDatabase, $_CORELANG, $objTemplate;
	    
	    if($this->tableExists == "tblexists") {
	    	$tdm = "<select name='fromDB' onchange='existingdirNameValue2()' size='1' style='WIDTH: 150px'>";  
	    	$tdm .="<option value=''>--- Aus Datenbank ----------</option>";                
			$objResult = $objDatabase->query("SELECT id,themesname FROM ".$this->oldTable." ORDER BY id");
			$defaultThemeId = $this->selectDefaultTheme();
			
			if ($objResult !== false) {
				while (!$objResult->EOF) {
					if($objResult->fields['id'] == $defaultThemeId) $default = "(".$_CORELANG['TXT_DEFAULT'].")";										
					$tdm .="<option value='".$objResult->fields['id']."'>".$objResult->fields['themesname']." ".$default."</option>\n";
					$default='';
					$objResult->MoveNext();
				}
			}
			$tdm .="</select>";
	    	$objTemplate->setVariable('TXT_FROM_DB',$tdm);
	    }    	
    }
    
    
    
    function createFilesFromDB($themes, $fromDB)
    {
    	global $_CONFIG, $objDatabase, $_CORELANG;
    	
    	$themePages = array();
    	
    	$objResult = $objDatabase->Execute("SELECT * FROM ".$this->oldTable." WHERE id='".$fromDB."'");
    	if ($objResult !== false) {
			while (!$objResult->EOF) {									
				$themePages['index.html'] = stripslashes($objResult->fields['indexpage']);
				$themePages['content.html'] =  stripslashes($objResult->fields['content']);
				$themePages['home.html'] =  stripslashes($objResult->fields['home']);
				$themePages['navbar.html'] =  stripslashes($objResult->fields['navbar']);
				$themePages['subnavbar.html'] =  stripslashes($objResult->fields['subnavbar']);
				$themePages['sidebar.html'] =  stripslashes($objResult->fields['sidebar']);
				$themePages['shopnavbar.html'] =  stripslashes($objResult->fields['shopnavbar']);
				$themePages['headlines.html'] =  stripslashes($objResult->fields['headlines']);
				$themePages['javascript.js'] =  stripslashes($objResult->fields['javascript']);
				$themePages['style.css'] =  stripslashes($objResult->fields['style']);
				$objResult->MoveNext();
			}
    	}
		
		for($x = 0; $x < count($this->filenames); $x++) {
            $fp = fopen ($this->path.$themes."/".$this->filenames[$x] ,"w");
			fwrite($fp,"");
			fclose($fp);
            
            $filename = $this->path.$themes."/".$this->filenames[$x];
            
			//check, if file exists and is writable
            if (is_writable($filename)) {
            	//open file
			   	if (!$handle = fopen($filename, "a")) {
			         $this->statusMessage = $_CORELANG['TXT_STATUS_CANNOT_OPEN'];
			   	}
			   	//write file
			   	if (!fwrite($handle, $themePages[$this->filenames[$x]])) {
			   	    $this->statusMessage =  $_CORELANG['TXT_STATUS_CANNOT_WRITE'];
			   	}
			   	fclose($handle);
			   	//$db->query("DELETE FROM $this->oldTable WHERE id = '$fromDB'");  
			   	$this->statusMessage = $_CORELANG['TXT_STATUS_SUCCESSFULLY_CREATE'];
			
			} else {
			    $this->statusMessage = $_CORELANG['TXT_STATUS_CANNOT_WRITE'];
			}
        }
   }
   
   
   
   /**
    * if now rows in table -> drop table 
    *
    * @access   public
    * @param    string   $table
    */
    function dropTable($table)
    {	
    	global $_CONFIG, $objDatabase, $_CORELANG;
    	                  
		$objResult = $objDatabase->Execute("SELECT id FROM ".$this->oldTable." ORDER BY id");
		if ($objResult !== false) {
			$count = $objResult->RecordCount();
			if ($count == 0) {
				$objDatabase->Execute("DROP TABLE ".$this->table);
			}
		}
    }
}
?>