<?PHP
/**
* Modul Gallery
*
* External functions for the gallery
*
* @copyright CONTREXX CMS - Astalavista IT Engineering GmbH Thun
* @author Astalavista Development Team <thun@astalvista.ch> 
* @module gallery
* @modulegroup modules 
* @access public
* @version 1.0.0  
*/

class Gallery {
	var $ArraySettings;
	var $imagePath;
	var $imageWebPath;
	var $thumbnailPath;	
	var $thumbnailWebPath;
	var $_objTpl;
	var $pageContent;
	var $categoryTree;	
	
	
	/**
    * Constructor php5
    *
    * @param  string  
    * @access public
    */   
    function Gallery($pageContent)
    { 
    	$this->__construct($pageContent);    
    }    	

	
	/*
	* Constructor
    *
    * @global	array	$_ARRAYLANG
    * @global	var		$db
    */ 	
	function __construct($pageContent)
	{
		global $objDb, $_ARRAYLANG;
		
		$this->pageContent = $pageContent;
		
	    $this->_objTpl = &new HTML_Template_Sigma('.');
		$this->_objTpl->setErrorHandling(PEAR_ERROR_DIE); 		
		
	    $this->imagePath = ASCMS_GALLERY_PATH . '/';
	    $this->imageWebPath = ASCMS_GALLERY_WEB_PATH . '/';	    
	    $this->thumbnailPath = ASCMS_GALLERY_THUMBNAIL_PATH . '/';		    
	    $this->thumbnailWebPath = ASCMS_GALLERY_THUMBNAIL_WEB_PATH . '/';			
		
    	$objDb->query("SELECT name,value FROM ".DBPREFIX."module_gallery_settings");
    	
    	while ($objDb->next_record()) {
    		$this->ArraySettings[$objDb->f('name')] = $objDb->f('value');	
    	}  		
		$this->categoryTree = $this->categoryTree();
	}
	
	

	/*
	* Reads the act and selects the right action
    *
    */ 		
	function getPage()
	{
    	if(!isset($_GET['cmd'])) {
    		$_GET['cmd'] = '';
    	}
    			
		switch ($_GET['cmd']){
			case 'showCat':
				if(isset($_GET['pId']) && !empty($_GET['pId'])){
					$this->showPicture(intval($_GET['pId']));
				}				
				$this->showGallery(intval($_GET['cid']));
			break;
			default:
				if (isset($_GET['cid'])) {
					$this->showCategoryOverview(intval($_GET['cid']));
				} else {
					$this->showCategoryOverview();
				}
		}
		return $this->_objTpl->get(); 
	}
	
	
	
	
	
	function showPicture($pictureId)
	{
		global $objDb, $_ARRAYLANG;
		
		$arrPictures = array();
		// POPUP Code
		$objTpl = &new HTML_Template_Sigma(ASCMS_MODULE_PATH.'/gallery/template');
		$objTpl->loadTemplateFile('module_gallery_show_picture.html',true,true);
		
		// get category description
		$objDb->query("SELECT description
					FROM ".DBPREFIX."module_gallery_categories
					WHERE id=".intval($_GET['cid']));
		$objDb->next_record();
		$categoryComment = $objDb->f('description');
		
		// get picture informations
		$objDb->query("SELECT id,name,path,linkname,link,size_show
					FROM ".DBPREFIX."module_gallery_pictures
					WHERE id=".$pictureId);
		
		while ($objDb->next_record()){
			$imageReso = getimagesize($this->imagePath.$objDb->f('path'));
			$imagePath = $this->imageWebPath.$objDb->f('path');
			$imageName = $objDb->f('name');
			$imageSize = round(filesize($this->imagePath.$objDb->f('path'))/1024,2);
			$imageWebPath = ASCMS_PROTOCOL .'://'.$_SERVER['SERVER_NAME'].ASCMS_PATH_OFFSET.'/index.php?section=gallery&amp;cmd=showCat&amp;cid='.$_GET['cid'].'&amp;pId='.$pictureId;
		}
		
		// get pictures of the current category
		$objDb->query("SELECT id FROM ".DBPREFIX."module_gallery_pictures WHERE status='1' AND validated='1' AND catid=".intval($_GET['cid'])." ORDER BY id");
		while ($objDb->next_record()) {
			array_push($arrPictures,$objDb->f('id'));
		}
		
		// get next picture id
		if(array_key_exists(array_search($pictureId,$arrPictures)+1,$arrPictures)){
			$pictureIdNext = $arrPictures[array_search($pictureId,$arrPictures)+1];
		} else {
			$pictureIdNext = $arrPictures[0];
		}
		
		// get previous picture id
		if(array_key_exists(array_search($pictureId,$arrPictures)-1,$arrPictures)){
			$pictureIdPrevious = $arrPictures[array_search($pictureId,$arrPictures)-1];
		} else {
			$pictureIdPrevious = end($arrPictures);
		}
		
		// set language variables
		$objTpl->setVariable(array(
			'TXT_CLOSE_WINDOW'		=> $_ARRAYLANG['TXT_CLOSE_WINDOW'],
			'TXT_ZOOM_OUT'			=> $_ARRAYLANG['TXT_ZOOM_OUT'],
			'TXT_ZOOM_IN'			=> $_ARRAYLANG['TXT_ZOOM_IN'],
			'TXT_CHANGE_BG_COLOR'	=> $_ARRAYLANG['TXT_CHANGE_BG_COLOR'],
			'TXT_PRINT'				=> $_ARRAYLANG['TXT_PRINT'],
			'TXT_PREVIOUS_IMAGE'	=> $_ARRAYLANG['TXT_PREVIOUS_IMAGE'],
			'TXT_NEXT_IMAGE'		=> $_ARRAYLANG['TXT_NEXT_IMAGE'],
			'TXT_USER_DEFINED'		=> $_ARRAYLANG['TXT_USER_DEFINED']
		));
		
		// set variables
		$objTpl->setVariable(array(
			'IMAGE_THIS'		=> $imagePath,
			'IMAGE_PREVIOUS'	=> '?section=gallery&amp;cmd=showCat&amp;cid='.intval($_GET['cid']).'&amp;pId='.$pictureIdPrevious,
			'IMAGE_NEXT'		=> '?section=gallery&amp;cmd=showCat&amp;cid='.intval($_GET['cid']).'&amp;pId='.$pictureIdNext,
			'GALLERY_WINDOW_WIDTH'	=> $imageReso[0] < 420 ? 500 : $imageReso[0]+80,
			'GALLERY_WINDOW_HEIGHT'	=> $imageReso[1]+120,
			'IMAGE_WIDTH'		=> $imageReso[0],
			'IMAGE_HEIGHT'		=> $imageReso[1],
			'IMAGE_LINK'		=> $imageWebPath,
			'GALLERY_TITLE'		=> $categoryComment,
			'IMAGE_NAME'		=> $imageName,
			'IMAGE_DESCRIPTION'	=> $_ARRAYLANG['TXT_IMAGE_NAME'].': '.$imageName.'<br />'.$_ARRAYLANG['TXT_FILESIZE'].': '.$imageSize.' kB<br />'.$_ARRAYLANG['TXT_RESOLUTION'].': '.$imageReso[0].'x'.$imageReso[1].' Pixel',
		));
		$objTpl->show();
		die;
	}

	
	
	
	/*
	* Shows the Category-Tree
    *
    * @global	array	$_ARRAYLANG
    * @global	object	$db
    */ 	
	function categoryTree()
	{
		global $_ARRAYLANG, $db;
		
		$output = '<a href="?section=gallery" target="_self">'.$_ARRAYLANG['TXT_GALLERY'].'</a>';
		
		if (isset($_GET['cmd'])) { // this gallery is viewed
			$cmd = 'cmd=showCat';
		}
		
		if (isset($_GET['cid'])){
			$catId = intval($_GET['cid']);
			$db->query("SELECT name,pid
						FROM ".DBPREFIX."module_gallery_categories
						WHERE id=".$catId);
			$db->next_record();
			$category1 = $db->f('name');
			
			if ($db->f('pid') != 0){
				$parentId = $db->f('pid');
				$db->query("SELECT name
							FROM ".DBPREFIX."module_gallery_categories
							WHERE id=".$parentId);
				$db->next_record();
				$category2 = $db->f('name');
			}
			
			if (isset($category2)){ // this is a subcategory
				$output .= ' / <a href="?section=gallery&amp;cid='.$parentId.'" target="_self">'.$category2.'</a>';
				$output .= ' / <a href="?section=gallery&amp;'.$cmd.'&amp;cid='.$catId.'" target="_self">'.$category1.'</a>';
			} else {
				$output .= ' / <a href="?section=gallery&amp;'.$cmd.'&amp;cid='.$catId.'" target="_self">'.$category1.'</a>';
			}
		}
		return $output;	
	}
	
	
	
	/*
	* Shows the Overview of categories
    *
    * @global	array	$_ARRAYLANG
    * @global	object	$db
    * @param	var		$parentId
    */ 
	function showCategoryOverview($parentId=0)
	{
		global $db,$_ARRAYLANG;
		
		$this->_objTpl->setTemplate($this->pageContent, true, true);
		$this->_objTpl->setVariable('CATEGORYTREE',$this->categoryTree);
	
		$db->query("SELECT id,catid,path
					FROM ".DBPREFIX."module_gallery_pictures
					ORDER BY id");
		
		while ($db->next_record()){
			$arrImageSizes[$db->f('catid')][$db->f('id')] = round(filesize($this->imagePath.$db->f('path'))/1024,2);
			$arrImagePaths[$db->f('catid')][$db->f('id')] = $this->thumbnailWebPath.$db->f('path');
		}
		
		$db->query("SELECT pid
					FROM ".DBPREFIX."module_gallery_categories
					WHERE status='1' AND pid <> 0");
		
		while ($db->next_record()){
			$arrCategorySubCats[$db->f('pid')]++;
		}
		
		if (isset($arrImageSizes) && isset($arrImagePaths)) {
			foreach ($arrImageSizes as $keyCat => $valueCat) {		
				foreach ($valueCat as $keyImage => $valueImageSize){
					$arrCategorySizes[$keyCat] = $arrCategorySizes[$keyCat] + $valueImageSize;
				}
			}
			foreach ($arrImagePaths as $keyCat => $valueCat) {
				foreach ($valueCat as $keyImage => $valueImagePath){	
					$arrCategoryImages[$keyCat]	= $valueImagePath;
					$arrCategoryImageCounter[$keyCat] = $arrCategoryImageCounter[$keyCat] + 1;
				}	
			}
		}
		//$arrCategorySizes			->		Sizes of all Categories
		//$arrCategorySubCats		->		Counts the Subcategories
		//$arrCategoryImages		->		The First Picture of each category
		//$arrCategoryImageCounter	->		Counts all images in one group
		
		$db->query("SELECT *
					FROM ".DBPREFIX."module_gallery_categories
					WHERE pid=".$parentId." AND status='1'
					ORDER BY sorting ASC");
		
		if ($db->num_rows() == 0) { // no categories in the database, hide the output
			$this->_objTpl->hideBlock("showCategories");	
		}else {		
			$fillLastRow = 1;			
			while ($db->next_record()){	
				if (empty($arrCategoryImages[$db->f('id')]))
				{ // no pictures in this gallery, show the empty-image
					$output = '<img border="0" alt="'.$db->f('name').'" src="images/modules/gallery/no_images.gif" alt=\"\"/>';
					$output .= '<br /><b>'.$db->f('name').'</b>';
					$output .= '<br />'.$_ARRAYLANG['TXT_IMAGE_COUNT'].': 0';
					$output .= '<br />'.$_ARRAYLANG['TXT_SIZE'].': 0kB';
				} else {
					$output = '<a href="?section=gallery&amp;cmd=showCat&amp;cid='.$db->f('id').'" target="_self">';
					$output .= '<img border="0" alt="'.$db->f('name').'" src="'.$arrCategoryImages[$db->f('id')].'" /></a>';
					$output .= '<br /><b>'.$db->f('name').'</b>';
					$output .= '<br />'.$_ARRAYLANG['TXT_IMAGE_COUNT'].': '.$arrCategoryImageCounter[$db->f('id')];
					$output .= '<br />'.$_ARRAYLANG['TXT_SIZE'].': '.$arrCategorySizes[$db->f('id')].'kB';
				}
				if (empty($arrCategorySubCats[$db->f('id')])) {
					$output .= '<br /><br /><br />';	
				} else {
					$output .= 	'<br /><a href="?section=gallery&amp;cid='.$db->f('id').'" target="_self">
								'.$_ARRAYLANG['TXT_GALLERY_EXTERNAL_SUB_CATS'].': '.$arrCategorySubCats[$db->f('id')].'</a><br><br>';	
				}
					
					$this->_objTpl->setVariable('CATEGORY'.$fillLastRow,$output);
					if ($fillLastRow == 3) {
						$fillLastRow = 1;
						$this->_objTpl->parse("showCategories");
					} else {
						$fillLastRow++;
					}
			}
			
			if ($fillLastRow == 2) {
				$fillLastRow++;
				$this->_objTpl->setVariable('CATEGORY2','');
			}
			if ($fillLastRow == 3) {
				$this->_objTpl->setVariable('CATEGORY3','');
				$this->_objTpl->parse("showCategories");
			}
		}
	}
	
	
	
	
	/*
	* Shows the images of a category
    *
    * @global	array	$_ARRAYLANG
    * @global	object	$db
    * @param	var		$catId
    */ 	
	function showGallery($catId)
	{
		global $db, $_ARRAYLANG;
		
		$this->_objTpl->setTemplate($this->pageContent, true, true);
		$this->_objTpl->setVariable("GALLERY_JAVASCRIPT", $this->getJavascript());
		$this->_objTpl->setVariable('CATEGORYTREE',$this->categoryTree);
		
		$db->query("SELECT description
					FROM ".DBPREFIX."module_gallery_categories
					WHERE id=".intval($catId));
		$db->next_record();
		$categoryComment = $db->f('description');
		
		$db->query("SELECT id,name,path,linkname,link,size_show
					FROM ".DBPREFIX."module_gallery_pictures
					WHERE status='1' AND validated='1' AND catid=".$catId."
					ORDER BY id");
		
		if ($db->num_rows() == 0){ // No images in the category
			$this->_objTpl->setVariable(array(
				HIDE_S			=>	'<!--',
				HIDE_E			=>	'-->',
				CATEGORYCOMMENT =>	$categoryComment
				));		
		}else{
			$this->_objTpl->setVariable(array(
				HIDE_S			=>	'',
				HIDE_E			=>	'',
				CATEGORYCOMMENT =>	$categoryComment
				));	
			
				$fillLastRow = 1;

				while ($db->next_record()){
					$imageFileSize = round(filesize($this->imagePath.$db->f('path'))/1024,2);
					$imageReso = getimagesize($this->imagePath.$db->f('path'));
					$imagePath = $this->imageWebPath.$db->f('path');
					$imageThumbPath = $this->thumbnailWebPath.$db->f('path');
					$imageName = $db->f('name');
					$imageLinkName = $db->f('linkname');
					$imageLink = $db->f('link');
					$imageSizeShow = $db->f('size_show');
					$imageLinkOutput = "";
					$imageSizeOutput = "";				
					
					$imageOutput = '<a href="javascript:openWindow(\'';
					$imageOutput .= '?section=gallery&cmd=showCat&cid='.$catId.'&pId='.$db->f('id');
					$imageOutput .= '\',\'\',\'width=';
					$imageOutput .= $imageReso[0]+25;
					$imageOutput .= ',height=';
					$imageOutput .= $imageReso[1]+25;
					$imageOutput .= ',resizable=yes';
					$imageOutput .= ',status=no';
					$imageOutput .= ',scrollbars=yes';
					$imageOutput .= '\')"><img border="0" title="'.$imageName.'" src="';
					$imageOutput .= $imageThumbPath;
					$imageOutput .= '" alt="';
					$imageOutput .= $imageName;
					$imageOutput .= '" /></a>';
					
					if ($this->ArraySettings['show_names'] == 'on'){
						$imageSizeOutput = $imageName;					
						if ($imageSizeShow == '1'){ 
							// the size of the file has to be shown
							$imageSizeOutput .= " ( ".$imageFileSize." kB)<br>";
						}
					} 					
			
					if (!empty($imageLinkName)){
						if (!empty($imageLink)){
							$imageLinkOutput = "<a href=\"".$imageLink."\" target='_blank'>".$imageLinkName."</a>";				
						}else {
						    $imageLinkOutput = $imageLinkName; 	
						}
					}else{
						if (!empty($imageLink)){
							$imageLinkOutput = "<a href=\"".$imageLink."\" target='_blank'>".$imageLink."</a>";							
						}
					}									

					$this->_objTpl->setVariable("IMAGELINK".$fillLastRow,$imageSizeOutput.$imageLinkOutput);				
					$this->_objTpl->setVariable("IMAGE".$fillLastRow, $imageOutput);
									
					if ($fillLastRow == 3){	
						// Parse the data after every third image
						$this->_objTpl->parse('showImages');
						$fillLastRow = 1;				
					}else {
						$fillLastRow++;
					}
				}
				if ($fillLastRow == 2){
					$this->_objTpl->setVariable("IMAGE".$fillLastRow,"");
					$this->_objTpl->setVariable("IMAGELINK".$fillLastRow,"");	
					$fillLastRow++;
				}		
				if ($fillLastRow == 3){
					$this->_objTpl->setVariable("IMAGE".$fillLastRow,"");
					$this->_objTpl->setVariable("IMAGELINK".$fillLastRow,"");	
					$this->_objTpl->parse('showImages');	
				}				
		}
	}
	
	
	
	/*
	* Writes the javascript-function into the template
    *
    */	
	function getJavascript()
	{		
		$javascript = <<<END
				
					<script language="JavaScript" type="text/JavaScript">
					function openWindow(theURL,winName,features) {
					    galleryPopup = window.open(theURL,"gallery",features);
					    galleryPopup.focus();
					}
					</script>
END;
		return $javascript;
	}		
}
?>